<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../../bower_components/paper-input/paper-input.html">

<dom-module id="mi-propiedades">
  <template>
    <style>
      :host {
        display: block;
      }
    </style>
    <h2>Hello [[prop1]]!</h2>
    <span>Otra propiedad: "[[currentValue]]"</span>
    <br>
    <button on-click="cambiarValor">Has clic para cambiar el valor</button>
    <h3>Data binding</h3>
    <a href="[[url]]">[[url]]</a>
    <paper-input label="Escribe algo" value="{{url}}"></paper-input>

    <h3>Observers</h3>
    <p>[[valoracion]]</p>

    <h3>Computed properties</h3>
    <fieldset>
      <label>Primer numero: [[param1]]</label><br>
      <label>Segundo numero: [[param2]]</label><br>
      <p><strong>La suma es: </strong> [[totalCalculo]]</p>
    </fieldset>
  </template>

  <script>
    /**
     * `mi-propiedades`
     * 
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class MiPropiedades extends Polymer.Element {
      static get is() { return 'mi-propiedades'; }
      static get properties() {
        return {
          prop1: {
            type: String,
            value: 'mi-propiedades'
          },
          param1: Number,
          param2: Number,
          fechaTransacion: {
            type: Date,
            value: new Date(),
            readOnly: true,
            reflectToAttribute: true
          },
          currentValue: {
            type: String,
          },
          url: {
            type: String,
            value: "www.google.com"
          },
          valoracion: {
            type: String,
            notify:true,
            observer: '_valoracionObserver',
          },
          totalCalculo: {
            type: Number,
            value: 0,
            readOnly: true,
            notify: true,
            computed: 'sumaTotalesTransacion(param1, param2)'
          }
        };
      }

      cambiarValor(){
        this.fechaTransacion = Date.now();
        this.valoracion = Date.now();
      }

      _valoracionObserver(newValue, oldValue){
        if( newValue === undefined) {
          console.log(" if es igual a true !! ");
          console.log("el nuevo valor es: " + newValue);
        }else {
          console.log("oldValue: ", oldValue);
        }
      }

      sumaTotalesTransacion(pm1, pm2){
        return pm1+pm2;
      }
    }

    window.customElements.define(MiPropiedades.is, MiPropiedades);
  </script>
</dom-module>
